////////////////////////////////////////////////
//
//     -- Mikael Beckius 2008 --
//
////////////////////////////////////////////////

#include <EGL\egl.h>
#include <VG\openvg.h>
#include <VG\vgu.h>
#include "fighterRGBA.h"

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

// staticVGfloat vertices[]   = { 0.0f,0.0f, 50.0f,0.0f, -25.0f,25.0f};
static VGfloat vertices[] ={-40,40, -40,-40, 40,40, 40,-40}; 
// static VGfloat texCoords[] = {0.0,1.0, 0.0,0.0, 1.0,1.0, 1.0,0.0};

int main(int argc, char** argv){
	int frame = 0;

	EGLDisplay dpy;
	EGLSurface surface;
	EGLContext context;
	EGLConfig configs[2];
	EGLint config_count;
	EGLint major, minor; 
	EGLint cfg_attribs[] = {EGL_BUFFER_SIZE,    EGL_DONT_CARE,
		EGL_RENDERABLE_TYPE, EGL_OPENGL_ES2_BIT,
		EGL_RED_SIZE,       8,
		EGL_GREEN_SIZE,     8,
		EGL_BLUE_SIZE,      8,
		EGL_ALPHA_SIZE,     8,
		EGL_DEPTH_SIZE,			16,
		EGL_NONE};

	dpy = eglGetDisplay (EGL_DEFAULT_DISPLAY);
	if(!eglInitialize(dpy, &major, &minor)){
		printf("eglInitialize failed");
	}
	if(!eglBindAPI(EGL_OPENGL_ES_API)){
		printf("eglBindAPI failed");
	}
	if(!eglGetConfigs (dpy, configs, 2, &config_count)){
		printf("eglGetConfigs failed");
	}
	if(!eglChooseConfig (dpy, cfg_attribs, configs, 2, &config_count)){
		printf("eglChooseConfig failed");
	}
	surface = eglCreateWindowSurface (dpy, configs[0], 0, 0);
	if(!surface){
		printf("eglCreateWindowSurface failed");
	}
	context = eglCreateContext (dpy, configs[0], EGL_NO_CONTEXT, 0);
	if(!context){
		printf("eglCreateContext failed");
	}

	if(!eglMakeCurrent(dpy, surface, surface, context)){
		printf("eglMakeCurrent failed");
	}

	VGfloat clearColor[4] = { 0.0f, 0.0f, 0.0f, 0.0f };
	vgSetfv(VG_CLEAR_COLOR, 4, clearColor);

	VGPath  path;
	VGubyte segments[] = { VG_MOVE_TO_ABS, VG_MOVE_TO_ABS, VG_MOVE_TO_ABS, VG_MOVE_TO_ABS, VG_CLOSE_PATH };
	path = vgCreatePath(VG_PATH_FORMAT_STANDARD, VG_PATH_DATATYPE_F, 1.0f, 0.0f, 0, 0, VG_PATH_CAPABILITY_ALL);
	vgAppendPathData( path, 5, segments, vertices );

/*

	unsigned int id;
  glGenTextures(1,&id);
  glBindTexture(GL_TEXTURE_2D,id);
  glPixelStorei(GL_UNPACK_ALIGNMENT,1);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_BGRA, 256, 256, 0, GL_BGRA, GL_UNSIGNED_BYTE, imageFighterRGBA);
*/
	VGImage image = vgCreateImage(VG_lBGRA_8888,256,256,VG_IMAGE_QUALITY_BETTER);
	VGErrorCode e = VG_NO_ERROR;
	do{
	  e=vgGetError();
		printf("main vgGetError %u\n",e);
	}while(e!=VG_NO_ERROR);


	while(frame++<10000){
		vgClear(0,0,240,320);
		
		vgSeti(VG_MATRIX_MODE, VG_MATRIX_PATH_USER_TO_SURFACE);
		vgLoadIdentity();
		vgTranslate(120,160);
		vgRotate(-frame/100.0f);
		vgDrawPath( path, VG_STROKE_PATH );
		
		vgImageSubData(image, imageFighterRGBA, 256*4, VG_lBGRA_8888, 0, 0, 256, 256 );
		vgSeti(VG_MATRIX_MODE, VG_MATRIX_IMAGE_USER_TO_SURFACE);
		vgLoadIdentity();
		vgTranslate(120,160);
		vgRotate(frame/100.0f);
		vgDrawImage(image);
		eglSwapBuffers (dpy, surface);
	}
	vgDestroyImage(image);
	vgDestroyPath(path);

	eglMakeCurrent(dpy, EGL_NO_SURFACE, EGL_NO_SURFACE, EGL_NO_CONTEXT);
	eglDestroyContext(dpy, context);
	eglDestroySurface(dpy, surface);
	eglTerminate(dpy);
	return 0;
}
